unit UWIADemo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleServer, RXSpin, ComCtrls, ExtCtrls, shellapi, ShlObj,
  UWIAScan, jpeg;

type
  TfrmWIATest = class(TForm)
    PageControl1: TPageControl;
    tsPic: TTabSheet;
    tsDump: TTabSheet;
    Memo1: TMemo;
    ScrollBox1: TScrollBox;
    imScan: TImage;
    Panel1: TPanel;
    Label1: TLabel;
    btnScan: TButton;
    btnDump: TButton;
    seDPI: TRxSpinEdit;
    Label2: TLabel;
    cbDevice: TComboBox;
    Label3: TLabel;
    lbRes: TLabel;
    Label4: TLabel;
    lbResBed: TLabel;
    wiascan: TWIAScan;
    Label5: TLabel;
    lbState: TLabel;
    tbAbout: TTabSheet;
    Memo2: TMemo;
    btnBuy: TButton;
    cbGrayscale: TCheckBox;
    cbPartial: TCheckBox;
    btnHelp: TButton;
    procedure btnScanClick(Sender: TObject);
    procedure btnDumpClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure wiascanScanAbort(Sender: TObject);
    procedure wiascanScanError(Sender: TObject);
    procedure cbDeviceChange(Sender: TObject);
    procedure btnBuyClick(Sender: TObject);
    procedure btnHelpClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmWIATest: TfrmWIATest;

implementation

{$R *.dfm}


  procedure TfrmWIATest.btnScanClick(Sender: TObject);
  begin
    // set DPI
    wiascan.DPI := seDPI.AsInteger;

    // set device
    if cbDevice.ItemIndex >= 0 then
       wiascan.SelectedDevice := cbDevice.Items[ cbDevice.ItemIndex];

    if cbGrayscale.Checked then
       wiascan.Intent := wiGrayscale
    else
       wiascan.Intent := wiColor;

    if cbPartial.Checked then
       wiascan.ScanArea := wsaPartial
    else
       wiascan.ScanArea := wsaFull;

    // just scan
    wiascan.Open := TRUE;
    if wiascan.PerformScan then begin
       MessageDlg( 'success!', mtInformation, [mbOK], 0);
       PageControl1.ActivePage := tsPic;
       imScan.Picture.Assign( wiascan.Graphic);
       lbRes.Caption := inttostr( imScan.Picture.Width)+' x '+inttostr( imScan.Picture.Height);
    end;
  end;


  procedure TfrmWIATest.btnDumpClick(Sender: TObject);
  begin
    // set device
    if cbDevice.ItemIndex >= 0 then
       wiascan.SelectedDevice := cbDevice.Items[ cbDevice.ItemIndex];

    // read dump into memo control
    memo1.Lines.Assign( wiascan.ReadDump);
    
    PageControl1.ActivePage := tsDump;
  end;


  procedure TfrmWIATest.FormShow(Sender: TObject);
  begin
    cbDevice.Items.Assign( wiascan.Devices);
    case wiascan.WIAPresent of
         wpYes              : lbState.Caption := 'YES!';
         wpNo               : lbState.Caption := 'NO :(';
         wpUnknown          : lbState.Caption := 'not tested yet';
    end;
  end;


  procedure TfrmWIATest.wiascanScanAbort(Sender: TObject);
  begin
    MessageDlg( 'Scanning has been aborted!', mtInformation, [mbOK], 0);
  end;


  procedure TfrmWIATest.wiascanScanError(Sender: TObject);
  begin
    MessageDlg( 'Error during scan!', mtInformation, [mbOK], 0);
  end;


  procedure TfrmWIATest.cbDeviceChange(Sender: TObject);
  begin
    // set device
    wiascan.SelectedDevice := cbDevice.Items[ cbDevice.ItemIndex];

    // read out bed size
    lbResBed.Caption := inttostr( wiascan.BedWidthDPI)+' x '+inttostr( wiascan.BedHeightDPI);
  end;


  procedure TfrmWIATest.btnBuyClick(Sender: TObject);
  begin
    ShellExecute( 0, 'open', 'http://chimera.hu/TWIAScanDelphi/?register', nil, nil, SW_SHOW);
  end;


  procedure TfrmWIATest.btnHelpClick(Sender: TObject);
  begin
    ShellExecute( 0, 'open', 'http://chimera.hu/TWIAScanDelphi/?description', nil, nil, SW_SHOW);
  end;


end.
